' plot impulse response with bootstrap standard errors
' need to pass matrix returned by matbys= option of impulse
' checked 3/25/2004

' rsp = name of matrix returned by matbys = option
' upp = name of matrix of containing upper bounds for each column of rsp
' low = name of matrix of containing lower bounds for each column of rsp
' %gname = name for final combined graph

subroutine sub_bootirf(matrix rsp, matrix upp, matrix low, string %gname)

'smpl 1975q1 1997q4

!hrz = @rows(rsp)
!k2 = @columns(rsp)
!sqrt_k2 = @sqrt(!k2)

vector v
vector vbd

matrix(!hrz,3) tmp

%namelist = ""
'%namelist = %gname
' plot each graph separately 
	for !c=1 to !k2
		' get point estimates
		v = @columnextract(rsp,!c)
		colplace(tmp,v,1)		
		' get bounds
		vbd = @columnextract(upp,!c)
		colplace(tmp,vbd,2)		
		vbd = @columnextract(low,!c)
		colplace(tmp,vbd,3)
		if !c>=4 and !c<=6 then
			tmp = tmp*(-1)
		endif
		' make individual graph
		freeze(tmp_graph{!c}) tmp.line
		tmp_graph{!c}.option linepat	' need to set linepat
		tmp_graph{!c}.elem(1) lcolor(blue) lpat(solid) lwidth(2) SYM(CIRCLE) symbolsize(4xl)
		tmp_graph{!c}.elem(2) lcolor(blue) lpat(dash7) lwidth(0.25)
		tmp_graph{!c}.elem(3) lcolor(blue) lpat(dash7) lwidth(0.25)
		tmp_graph{!c}.legend(off)
'		tmp_graph{!c}.legend -display
          tmp_graph{!c}.axis(l) grid zeroline label
          tmp_graph{!c}.options backfade(none) backcolor(white)	frameaxes(lb) gridpat(dash2)
		tmp_graph{!c}.addtext(l,font("Times New Roman",16)) percent		
		tmp_graph{!c}.addtext(b,font("Times New Roman",16)) quarter
		%namelist = %namelist + "tmp_graph" + @str(!c) + " "		
		if !c>=1 and !c<=!sqrt_k2 then
			tmp_graph{!c}.axis(l) range(-2,1)
			tmp_graph{!c}.addtext(t,font("Times New Roman",20))  "Tax shocks with sample 1978q1"%enddate
		else 
			tmp_graph{!c}.axis(l) range(-1.5,2.5)
			tmp_graph{!c}.addtext(t,font("Times New Roman",20))  "Expenditure shocks with sample 1978q1"%enddate
		endif
	next

' combine graphs
'freeze({%gname}) tmp_graph1 tmp_graph4 tmp_graph7 tmp_graph2 tmp_graph5 tmp_graph8 tmp_graph3 tmp_graph6 tmp_graph9

freeze({%gname}) tmp_graph1 tmp_graph4 tmp_graph2 tmp_graph5 tmp_graph3 tmp_graph6

'delete v vbd tmp {%namelist} 
endsub
